!=========================================================================
! Copyright (C) GemTalk Systems 1986-2019.  All Rights Reserved.
!=========================================================================

doit
TestResult subclass: 'GSTestResult'
  instVarNames: #()
  classVars: #()
  classInstVars: #()
  poolDictionaries: { }
  inDictionary: Globals
%

! Remove existing behavior from GSTestResult
doit
GSTestResult removeAllMethods.
GSTestResult class removeAllMethods.
"To satisfy forward refs"
(Globals includesKey: #GSTestCase) ifFalse: [Globals at: #GSTestCase put: nil]
%
! ------------------- Class methods for GSTestResult
! ------------------- Instance methods for GSTestResult
category: 'other'
set compile_env: 0
method: GSTestResult
runCase: aTestCase
  [
    [  aTestCase runCase.
       self passed add: aTestCase.
    ] on: self class failure do: [:ex |
       self failures add: aTestCase.
       GSTestCase logCr: 'fail - ' , ex description asString.
       self
    ].
  ] on: (Error, Notification) do: [:ex | 
     ex class defaultHandlers size > 0 ifTrue:[ ex pass ].
     self errors add: aTestCase.
     GSTestCase logCr: 'error - ' , ex description asString .
     (SessionTemps current at:#Ernie_debug otherwise: false) ifFalse:[
        GSTestCase logCr:'------------------------------(
' , (GsProcess stackReportToLevel:300) , '
------------------------------)'.
     ].
     self
  ].
%
