!=========================================================================
! Copyright (C) GemTalk Systems 1986-2019.  All Rights Reserved.
!
! $Id: variablecon.gs 45331 2019-01-17 00:33:32Z lalmarod $
!
! Superclass Hierarchy:
!   VariableContext, Object.
!
!=========================================================================

removeallmethods VariableContext
removeallclassmethods VariableContext

category: 'For Documentation Installation only'
classmethod: VariableContext
installDocumentation

self comment:
'VariableContext implements GemStone internals. It is not intended for 
customer use, by creating instances or by subclassing.

Constraints:
	_copyForContinuation: VariableContext
	vcSerialNum: SmallInteger'.
%

category: 'Copying'
method: VariableContext
copy

"Disallowed."

self shouldNotImplement: #copy
%

category: 'Instance Creation'
classmethod: VariableContext
new

"Disallowed."

self shouldNotImplement: #new
%

! fix 6585
category: 'Instance Creation'
classmethod: VariableContext
new: aSize

"Disallowed."

self shouldNotImplement: #new:
%

category: 'Updating'
method: VariableContext
at: anIndex put: aValue

"Disallowed."

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: VariableContext
size: anInteger

"Disallowed."

self shouldNotImplement: #size:
%

category: 'Accessing'
method: VariableContext
parent
  ^ parent  "may be nil"
%
